From faabeadf9f3a72f159177108d73ec3418b9cd28a Mon Sep 17 00:00:00 2001
From: Merlijn Wajer <merlijn@wizzup.org>
Date: Sun, 13 May 2012 00:02:33 +0200
Subject: [PATCH] Change most methods to cdecl.

---
 lape.inc                     |    3 +
 lpeval.pas                   |  206 +-
 lpeval_functions.inc         | 5659 +++++++++++++++++++++---------------------
 lpeval_headers_datetime.inc  |   38 +-
 lpeval_headers_math.inc      |   40 +-
 lpeval_headers_string.inc    |  100 +-
 lpeval_headers_variant.inc   |  104 +-
 lpeval_wrappers_datetime.inc |   38 +-
 lpeval_wrappers_math.inc     |   40 +-
 lpeval_wrappers_string.inc   |  100 +-
 lpeval_wrappers_variant.inc  |   82 +-
 lptypes.pas                  |    6 +-
 12 files changed, 3229 insertions(+), 3187 deletions(-)

diff --git a/lape.inc b/lape.inc
index 3eb4461..36729fb 100644
--- a/lape.inc
+++ b/lape.inc
@@ -21,3 +21,6 @@
   {$DEFINE Delphi}
   {$POINTERMATH ON}
 {$ENDIF}
+
+{$MACRO ON}
+{$define lape_extdecl:=cdecl;}
\ No newline at end of file
diff --git a/lpeval.pas b/lpeval.pas
index 7805174..a53346a 100644
--- a/lpeval.pas
+++ b/lpeval.pas
@@ -22,57 +22,57 @@ type
   TGetEvalRes = function(Op: EOperator; Left, Right: ELapeBaseType): ELapeBaseType;
   TGetEvalProc = function(Op: EOperator; Left, Right: ELapeBaseType): TLapeEvalProc;
 
-procedure _LapeWrite(const Params: PParamArray);
-procedure _LapeWriteLn(const Params: PParamArray);
-
-procedure _LapeAssigned(const Params: PParamArray; const Result: Pointer);
-procedure _LapeRaise(const Params: PParamArray);
-procedure _LapeRaiseString(const Params: PParamArray);
-procedure _LapeAssert(const Params: PParamArray);
-procedure _LapeAssertMsg(const Params: PParamArray);
-
-procedure _LapeGetMem(const Params: PParamArray; const Result: Pointer);
-procedure _LapeAllocMem(const Params: PParamArray; const Result: Pointer);
-procedure _LapeFreeMem(const Params: PParamArray);
-procedure _LapeFreeMemSize(const Params: PParamArray);
-procedure _LapeReallocMem(const Params: PParamArray);
-procedure _LapeFillMem(const Params: PParamArray);
-procedure _LapeMove(const Params: PParamArray);
-
-procedure _LapeHigh(const Params: PParamArray; const Result: Pointer);
-procedure _LapeLength(const Params: PParamArray; const Result: Pointer);
-procedure _LapeAStr_GetLen(const Params: PParamArray; const Result: Pointer);
-procedure _LapeWStr_GetLen(const Params: PParamArray; const Result: Pointer);
-procedure _LapeUStr_GetLen(const Params: PParamArray; const Result: Pointer);
-procedure _LapeAStr_SetLen(const Params: PParamArray);
-procedure _LapeWStr_SetLen(const Params: PParamArray);
-procedure _LapeUStr_SetLen(const Params: PParamArray);
-
-procedure _LapeToString_Unknown(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_UInt8(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Int8(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_UInt16(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Int16(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_UInt32(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Int32(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_UInt64(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Int64(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Single(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Double(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Currency(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Extended(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Boolean(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_ByteBool(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_WordBool(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_LongBool(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_AnsiChar(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_WideChar(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_ShortString(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_AnsiString(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_WideString(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_UnicodeString(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Variant(const Params: PParamArray; const Result: Pointer);
-procedure _LapeToString_Pointer(const Params: PParamArray; const Result: Pointer);
+procedure _LapeWrite(const Params: PParamArray); lape_extdecl
+procedure _LapeWriteLn(const Params: PParamArray); lape_extdecl
+
+procedure _LapeAssigned(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeRaise(const Params: PParamArray); lape_extdecl
+procedure _LapeRaiseString(const Params: PParamArray); lape_extdecl
+procedure _LapeAssert(const Params: PParamArray); lape_extdecl
+procedure _LapeAssertMsg(const Params: PParamArray); lape_extdecl
+
+procedure _LapeGetMem(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeAllocMem(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeFreeMem(const Params: PParamArray); lape_extdecl
+procedure _LapeFreeMemSize(const Params: PParamArray); lape_extdecl
+procedure _LapeReallocMem(const Params: PParamArray); lape_extdecl
+procedure _LapeFillMem(const Params: PParamArray); lape_extdecl
+procedure _LapeMove(const Params: PParamArray); lape_extdecl
+
+procedure _LapeHigh(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeLength(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeAStr_GetLen(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeWStr_GetLen(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeUStr_GetLen(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeAStr_SetLen(const Params: PParamArray); lape_extdecl
+procedure _LapeWStr_SetLen(const Params: PParamArray); lape_extdecl
+procedure _LapeUStr_SetLen(const Params: PParamArray); lape_extdecl
+
+procedure _LapeToString_Unknown(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_UInt8(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Int8(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_UInt16(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Int16(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_UInt32(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Int32(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_UInt64(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Int64(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Single(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Double(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Currency(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Extended(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Boolean(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_ByteBool(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_WordBool(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_LongBool(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_AnsiChar(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_WideChar(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_ShortString(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_AnsiString(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_WideString(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_UnicodeString(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Variant(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeToString_Pointer(const Params: PParamArray; const Result: Pointer); lape_extdecl
 
 {$I lpeval_headers_math.inc}
 {$I lpeval_headers_string.inc}
@@ -85,7 +85,7 @@ procedure LoadToStrArr(var Arr: TLapeToStrArr);
 function ValidEvalFunction(p: Pointer): Boolean; overload; {$IFDEF Lape_Inline}inline;{$ENDIF}
 function ValidEvalFunction(p: TLapeEvalProc): Boolean; overload; {$IFDEF Lape_Inline}inline;{$ENDIF}
 
-procedure LapeEval_Error(const Dest, Left, Right: Pointer);
+procedure LapeEval_Error(const Dest, Left, Right: Pointer); lape_extdecl
 procedure ClearEvalRes(var Arr: TLapeEvalRes);
 procedure ClearEvalArr(var Arr: TLapeEvalArr);
 procedure LoadEvalRes(var Arr: TLapeEvalRes);
@@ -268,234 +268,234 @@ uses
 type
   PBoolean = ^Boolean; //Make sure it's not ^Byte
 
-procedure _LapeWrite(const Params: PParamArray);
+procedure _LapeWrite(const Params: PParamArray); lape_extdecl
 begin
   Write(PlpString(Params^[0])^);
 end;
 
-procedure _LapeWriteLn(const Params: PParamArray);
+procedure _LapeWriteLn(const Params: PParamArray); lape_extdecl
 begin
   WriteLn('');
 end;
 
-procedure _LapeAssigned(const Params: PParamArray; const Result: Pointer);
+procedure _LapeAssigned(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PEvalBool(Result)^ := Assigned(PPointer(Params^[0])^);
 end;
 
-procedure _LapeRaise(const Params: PParamArray);
+procedure _LapeRaise(const Params: PParamArray); lape_extdecl
 begin
   raise Exception(Params^[0]^);
 end;
 
-procedure _LapeRaiseString(const Params: PParamArray);
+procedure _LapeRaiseString(const Params: PParamArray); lape_extdecl
 begin
   LapeException(PlpString(Params^[0])^);
 end;
 
-procedure _LapeAssert(const Params: PParamArray);
+procedure _LapeAssert(const Params: PParamArray); lape_extdecl
 begin
   if (not PEvalBool(Params^[0])^) then
     LapeException(lpeAssertionFailure);
 end;
 
-procedure _LapeAssertMsg(const Params: PParamArray);
+procedure _LapeAssertMsg(const Params: PParamArray); lape_extdecl
 begin
   if (not PEvalBool(Params^[0])^) then
     LapeExceptionFmt(lpeAssertionFailureMsg, [PlpString(Params^[1])^]);
 end;
 
-procedure _LapeGetMem(const Params: PParamArray; const Result: Pointer);
+procedure _LapeGetMem(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   GetMem(PPointer(Result)^, PInt32(Params^[0])^);
 end;
 
-procedure _LapeAllocMem(const Params: PParamArray; const Result: Pointer);
+procedure _LapeAllocMem(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PPointer(Result)^ := AllocMem(PInt32(Params^[0])^);
 end;
 
-procedure _LapeFreeMem(const Params: PParamArray);
+procedure _LapeFreeMem(const Params: PParamArray); lape_extdecl
 begin
   FreeMem(PPointer(Params^[0])^);
 end;
 
-procedure _LapeFreeMemSize(const Params: PParamArray);
+procedure _LapeFreeMemSize(const Params: PParamArray); lape_extdecl
 begin
   FreeMem(PPointer(Params^[0])^, PInt32(Params^[1])^);
 end;
 
-procedure _LapeReallocMem(const Params: PParamArray);
+procedure _LapeReallocMem(const Params: PParamArray); lape_extdecl
 begin
   ReallocMem(PPointer(Params^[0])^, PInt32(Params^[1])^);
 end;
 
-procedure _LapeFillMem(const Params: PParamArray);
+procedure _LapeFillMem(const Params: PParamArray); lape_extdecl
 begin
   FillChar(Params^[0]^, PInt32(Params^[1])^, PUInt8(Params^[2])^);
 end;
 
-procedure _LapeMove(const Params: PParamArray);
+procedure _LapeMove(const Params: PParamArray); lape_extdecl
 begin
   Move(Params^[0]^, Params^[1]^, PInt32(Params^[2])^);
 end;
 
-procedure _LapeHigh(const Params: PParamArray; const Result: Pointer);
+procedure _LapeHigh(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PInt32(Result)^ := High(PCodeArray(Params^[0])^);
 end;
 
-procedure _LapeLength(const Params: PParamArray; const Result: Pointer);
+procedure _LapeLength(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PInt32(Result)^ := Length(PCodeArray(Params^[0])^);
 end;
 
-procedure _LapeAStr_GetLen(const Params: PParamArray; const Result: Pointer);
+procedure _LapeAStr_GetLen(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PInt32(Result)^ := Length(PAnsiString(Params^[0])^);
 end;
 
-procedure _LapeWStr_GetLen(const Params: PParamArray; const Result: Pointer);
+procedure _LapeWStr_GetLen(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PInt32(Result)^ := Length(PWideString(Params^[0])^);
 end;
 
-procedure _LapeUStr_GetLen(const Params: PParamArray; const Result: Pointer);
+procedure _LapeUStr_GetLen(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PInt32(Result)^ := Length(PUnicodeString(Params^[0])^);
 end;
 
-procedure _LapeAStr_SetLen(const Params: PParamArray);
+procedure _LapeAStr_SetLen(const Params: PParamArray); lape_extdecl
 begin
   SetLength(PAnsiString(Params^[0])^, PInt32(Params^[1])^);
 end;
 
-procedure _LapeWStr_SetLen(const Params: PParamArray);
+procedure _LapeWStr_SetLen(const Params: PParamArray); lape_extdecl
 begin
   SetLength(PWideString(Params^[0])^, PInt32(Params^[1])^);
 end;
 
-procedure _LapeUStr_SetLen(const Params: PParamArray);
+procedure _LapeUStr_SetLen(const Params: PParamArray); lape_extdecl
 begin
   SetLength(PUnicodeString(Params^[0])^, PInt32(Params^[1])^);
 end;
 
-procedure _LapeToString_Unknown(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Unknown(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := '*UNKNOWN*';
 end;
 
-procedure _LapeToString_UInt8(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_UInt8(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PUInt8(Params^[0])^);
 end;
 
-procedure _LapeToString_Int8(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Int8(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PInt8(Params^[0])^);
 end;
 
-procedure _LapeToString_UInt16(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_UInt16(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PUInt16(Params^[0])^);
 end;
 
-procedure _LapeToString_Int16(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Int16(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PInt16(Params^[0])^);
 end;
 
-procedure _LapeToString_UInt32(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_UInt32(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PUInt32(Params^[0])^);
 end;
 
-procedure _LapeToString_Int32(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Int32(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PInt32(Params^[0])^);
 end;
 
-procedure _LapeToString_UInt64(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_UInt64(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PUInt64(Params^[0])^);
 end;
 
-procedure _LapeToString_Int64(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Int64(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := IntToStr(PInt64(Params^[0])^);
 end;
 
-procedure _LapeToString_Single(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Single(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := FloatToStr(PSingle(Params^[0])^);
 end;
 
-procedure _LapeToString_Double(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Double(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := FloatToStr(PDouble(Params^[0])^);
 end;
 
-procedure _LapeToString_Currency(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Currency(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := FloatToStr(PCurrency(Params^[0])^);
 end;
 
-procedure _LapeToString_Extended(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Extended(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := FloatToStr(PExtended(Params^[0])^);
 end;
 
-procedure _LapeToString_Boolean(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Boolean(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := BoolToStr(PBoolean(Params^[0])^, True);
 end;
 
-procedure _LapeToString_ByteBool(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_ByteBool(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := BoolToStr(PBoolean(Params^[0])^, True);
 end;
 
-procedure _LapeToString_WordBool(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_WordBool(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := BoolToStr(PWordBool(Params^[0])^, True);
 end;
 
-procedure _LapeToString_LongBool(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_LongBool(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := BoolToStr(PLongBool(Params^[0])^, True);
 end;
 
-procedure _LapeToString_AnsiChar(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_AnsiChar(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := PAnsiChar(Params^[0])^;
 end;
 
-procedure _LapeToString_WideChar(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_WideChar(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := PWideChar(Params^[0])^;
 end;
 
-procedure _LapeToString_ShortString(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_ShortString(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := PShortString(Params^[0])^;
 end;
 
-procedure _LapeToString_AnsiString(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_AnsiString(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := PAnsiString(Params^[0])^;
 end;
 
-procedure _LapeToString_WideString(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_WideString(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := PWideString(Params^[0])^;
 end;
 
-procedure _LapeToString_UnicodeString(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_UnicodeString(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   PlpString(Result)^ := PUnicodeString(Params^[0])^;
 end;
 
-procedure _LapeToString_Variant(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Variant(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   try
     PlpString(Result)^ := VarToStr(PVariant(Params^[0])^);
@@ -504,7 +504,7 @@ begin
   end;
 end;
 
-procedure _LapeToString_Pointer(const Params: PParamArray; const Result: Pointer);
+procedure _LapeToString_Pointer(const Params: PParamArray; const Result: Pointer); lape_extdecl
 begin
   if (PPointer(Params^[0])^ = nil) then
     PlpString(Result)^ := 'nil'
@@ -567,7 +567,7 @@ begin
    Result := ValidEvalFunction(Pointer({$IFNDEF FPC}@{$ENDIF}p));
 end;
 
-procedure LapeEval_Error(const Dest, Left, Right: Pointer);
+procedure LapeEval_Error(const Dest, Left, Right: Pointer); lape_extdecl
 begin
   LapeException(lpeInvalidEvaluation);
 end;
@@ -606,12 +606,12 @@ begin
   {$I lpeval_arr.inc}
 end;
 
-procedure lpeAddr(const Dest, Left, Right: Pointer);
+procedure lpeAddr(const Dest, Left, Right: Pointer); lape_extdecl
 begin
   PPointer(Dest)^ := Left;
 end;
 
-procedure lpeDeref(const Dest, Left, Right: Pointer);
+procedure lpeDeref(const Dest, Left, Right: Pointer); lape_extdecl
 begin
   PPointer(Dest)^ := PPointer(Left)^;
 end;
@@ -644,4 +644,6 @@ initialization
   LoadEvalArr(LapeEvalArr);
 
 end.
+
+
 
\ No newline at end of file
diff --git a/lpeval_headers_datetime.inc b/lpeval_headers_datetime.inc
index 92c437c..f7704cf 100644
--- a/lpeval_headers_datetime.inc
+++ b/lpeval_headers_datetime.inc
@@ -7,26 +7,26 @@
 }
 {%MainUnit lpeval.pas}
 
-procedure _LapeEncodeDate(const Params: PParamArray; const Result: Pointer);
-procedure _LapeEncodeTime(const Params: PParamArray; const Result: Pointer);
-procedure _LapeDecodeDate(const Params: PParamArray);
-procedure _LapeDecodeDateFully(const Params: PParamArray; const Result: Pointer);
-procedure _LapeDecodeTime(const Params: PParamArray);
+procedure _LapeEncodeDate(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeEncodeTime(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeDecodeDate(const Params: PParamArray); lape_extdecl
+procedure _LapeDecodeDateFully(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeDecodeTime(const Params: PParamArray); lape_extdecl
 
-procedure _LapeDate(const Params: PParamArray; const Result: Pointer);
-procedure _LapeTime(const Params: PParamArray; const Result: Pointer);
-procedure _LapeNow(const Params: PParamArray; const Result: Pointer);
+procedure _LapeDate(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeTime(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeNow(const Params: PParamArray; const Result: Pointer); lape_extdecl
 
-procedure _LapeGetTickCount(const Params: PParamArray; const Result: Pointer);
-procedure _LapeSleep(const Params: PParamArray);
+procedure _LapeGetTickCount(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeSleep(const Params: PParamArray); lape_extdecl
 
-procedure _LapeReplaceTime(const Params: PParamArray);
-procedure _LapeReplaceDate(const Params: PParamArray);
+procedure _LapeReplaceTime(const Params: PParamArray); lape_extdecl
+procedure _LapeReplaceDate(const Params: PParamArray); lape_extdecl
 
-procedure _LapeFormatDateTime(const Params: PParamArray; const Result: Pointer);
-procedure _LapeStrToDate(const Params: PParamArray; const Result: Pointer);
-procedure _LapeStrToDateDef(const Params: PParamArray; const Result: Pointer);
-procedure _LapeStrToTime(const Params: PParamArray; const Result: Pointer);
-procedure _LapeStrToTimeDef(const Params: PParamArray; const Result: Pointer);
-procedure _LapeStrToDateTime(const Params: PParamArray; const Result: Pointer);
-procedure _LapeStrToDateTimeDef(const Params: PParamArray; const Result: Pointer);
+procedure _LapeFormatDateTime(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeStrToDate(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeStrToDateDef(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeStrToTime(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeStrToTimeDef(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeStrToDateTime(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeStrToDateTimeDef(const Params: PParamArray; const Result: Pointer); lape_extdecl
diff --git a/lpeval_headers_math.inc b/lpeval_headers_math.inc
index de7db8a..7ff0f32 100644
--- a/lpeval_headers_math.inc
+++ b/lpeval_headers_math.inc
@@ -7,24 +7,24 @@
 }
 {%MainUnit lpeval.pas}
 
-procedure _LapeAbs(const Params: PParamArray; const Result: Pointer);
-procedure _LapeAbsI(const Params: PParamArray; const Result: Pointer);
-procedure _LapeSqr(const Params: PParamArray; const Result: Pointer);
-procedure _LapeSqrt(const Params: PParamArray; const Result: Pointer);
-procedure _LapeArcTan(const Params: PParamArray; const Result: Pointer);
-procedure _LapeLn(const Params: PParamArray; const Result: Pointer);
-procedure _LapeSin(const Params: PParamArray; const Result: Pointer);
-procedure _LapeCos(const Params: PParamArray; const Result: Pointer);
-procedure _LapeExp(const Params: PParamArray; const Result: Pointer);
-procedure _LapeRound(const Params: PParamArray; const Result: Pointer);
-procedure _LapeRoundTo(const Params: PParamArray; const Result: Pointer);
-procedure _LapeFrac(const Params: PParamArray; const Result: Pointer);
-procedure _LapeInt(const Params: PParamArray; const Result: Pointer);
-procedure _LapeTrunc(const Params: PParamArray; const Result: Pointer);
-procedure _LapeCeil(const Params: PParamArray; const Result: Pointer);
-procedure _LapeFloor(const Params: PParamArray; const Result: Pointer);
+procedure _LapeAbs(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeAbsI(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeSqr(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeSqrt(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeArcTan(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeLn(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeSin(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeCos(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeExp(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeRound(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeRoundTo(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeFrac(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeInt(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeTrunc(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeCeil(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeFloor(const Params: PParamArray; const Result: Pointer); lape_extdecl
 
-procedure _LapeRandomRange(const Params: PParamArray; const Result: Pointer);
-procedure _LapeRandom(const Params: PParamArray; const Result: Pointer);
-procedure _LapeRandomF(const Params: PParamArray; const Result: Pointer);
-procedure _LapeRandomize(const Params: PParamArray);
+procedure _LapeRandomRange(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeRandom(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeRandomF(const Params: PParamArray; const Result: Pointer); lape_extdecl
+procedure _LapeRandomize(const Params: PParamArray); lape_extdecl
